#include <Wire.h>
#include <LiquidCrystal_I2C.h>

#include <DmxSimple.h>

#include <EEPROM.h>

int mennue = 20;
LiquidCrystal_I2C lcd1(0x27, 16, 2);
bool menue = HIGH;
void Unterprogramm9();

void Unterprogramm35();

int brightness1 = 0;
int brightness2 = 0;
int brightness3 = 0;
int brightness4 = 0;
int brightness5 = 0;
void Unterprogramm50();

void Unterprogramm7();

void Unterprogramm6();

long ZeitVariable = 0L;
void Unterprogramm11();

void Unterprogramm2();

void Unterprogramm8();

void Unterprogramm3();

void Unterprogramm33();

void Unterprogramm98();

void Unterprogramm34();

void Unterprogramm4();

void Unterprogramm5();

void Unterprogramm();

void Unterprogramm99();

void Unterprogramm37();


void setup() {
  pinMode( 7 , INPUT);
  pinMode( 8 , INPUT);
  lcd1.init();
  lcd1.backlight();
  lcd1.clear();
  DmxSimple.usePin(3);

  DmxSimple.maxChannel(40);

  mennue = 20;

  Unterprogramm33();

}

void loop() {
  if (( mennue == 20 )) {
      lcd1.clear();
      lcd1.setCursor(2,0);
      lcd1.print("joystick L-R");
      menue = HIGH;
      while ( ( menue == HIGH ) ) 	{
          Unterprogramm11();
          Unterprogramm35();
        }

    }
  Unterprogramm2();
  Unterprogramm3();
  Unterprogramm4();
  Unterprogramm5();
  Unterprogramm6();
  Unterprogramm7();
  Unterprogramm8();
  Unterprogramm9();
}

//moving head 2 pan tilt
void Unterprogramm9() {
  if (( mennue == 26 )) {
      lcd1.clear();
      lcd1.setCursor(1,0);
      lcd1.print("PAN u. TILT 2");
      lcd1.setCursor(0,1);
      lcd1.print("PAN");
      lcd1.setCursor(4,1);
      lcd1.print("TIL");
      lcd1.setCursor(8,1);
      lcd1.print("xPA");
      lcd1.setCursor(12,1);
      lcd1.print("xTI");
      delay( 700 );
      menue = HIGH;
      while ( ( menue == HIGH ) ) 	{
          if (( analogRead(A6) < 400 )) {
              mennue = ( mennue - 1 );
              delay( 600 );
              menue = LOW;
            }
          Unterprogramm();
          DmxSimple.write(40, brightness1);
          DmxSimple.write(41, brightness4);
          DmxSimple.write(42, brightness3);
          DmxSimple.write(43, brightness2);
        }

    }
}

//DMX Speicher loeschen
void Unterprogramm35() {
  if (( analogRead(A7) < 400 )) {
      brightness1 = 0;
      brightness2 = 0;
      brightness3 = 0;
      brightness4 = 0;
      brightness5 = 0;
      EEPROM.write( 1 , brightness1 ) ;
      EEPROM.write( 2 , brightness2 ) ;
      EEPROM.write( 3 , brightness3 ) ;
      EEPROM.write( 4 , brightness4 ) ;
      EEPROM.write( 5 , brightness5 ) ;
      analogWrite(5 , 120);
      delay( 500 );
      analogWrite(5 , 0);
    }
}

//moving head auto
void Unterprogramm50() {
  lcd1.setCursor(0,0);
  lcd1.print("PR1");
  lcd1.setCursor(0,1);
  lcd1.print(brightness2 );
  lcd1.setCursor(4,0);
  lcd1.print("PR2");
  lcd1.setCursor(4,1);
  lcd1.print(brightness5 );
  lcd1.setCursor(12,0);
  lcd1.print("SPE");
  lcd1.setCursor(12,1);
  lcd1.print(brightness1 );
}

//moving head 1 pan tilt
void Unterprogramm7() {
  if (( mennue == 23 )) {
      lcd1.clear();
      lcd1.setCursor(1,0);
      lcd1.print("PAN u. TILT 1");
      lcd1.setCursor(0,1);
      lcd1.print("PAN");
      lcd1.setCursor(4,1);
      lcd1.print("TIL");
      lcd1.setCursor(8,1);
      lcd1.print("xPA");
      lcd1.setCursor(12,1);
      lcd1.print("xTI");
      delay( 700 );
      menue = HIGH;
      while ( ( menue == HIGH ) ) 	{
          Unterprogramm11();
          Unterprogramm();
          DmxSimple.write(29, brightness1);
          DmxSimple.write(30, brightness4);
          DmxSimple.write(31, brightness3);
          DmxSimple.write(32, brightness2);
        }

    }
}

//moving head 1
void Unterprogramm6() {
  if (( mennue == 21 )) {
      lcd1.clear();
      lcd1.setCursor(1,0);
      lcd1.print("MH. 1 - 1");
      lcd1.setCursor(0,1);
      lcd1.print("STO");
      lcd1.setCursor(4,1);
      lcd1.print("GOB");
      lcd1.setCursor(8,1);
      lcd1.print("COL");
      lcd1.setCursor(12,1);
      lcd1.print("DIM");
      delay( 700 );
      menue = HIGH;
      while ( ( menue == HIGH ) ) 	{
          Unterprogramm();
          Unterprogramm11();
          if (digitalRead(8)) {
              DmxSimple.write(35, brightness1);
              DmxSimple.write(34, brightness4);
              DmxSimple.write(33, brightness3);
              DmxSimple.write(36, brightness2);
            }
          if (digitalRead(7)) {
            }
        }

    }
  if (( mennue == 22 )) {
      lcd1.clear();
      lcd1.setCursor(1,0);
      lcd1.print("MH 1 - 2");
      delay( 700 );
      menue = HIGH;
      while ( ( menue == HIGH ) ) 	{
          ZeitVariable = millis();
          while(ZeitVariable + 400L >= millis()) {		
              Unterprogramm();
              Unterprogramm11();
              Unterprogramm50();
              if (digitalRead(8)) {
                  Unterprogramm50();
                  DmxSimple.write(37, brightness1);
                  DmxSimple.write(38, brightness2);
                  DmxSimple.write(39, brightness5);
                }
              if (digitalRead(7)) {
                }
            }
          lcd1.clear();
        }

    }
}

//moving head
void Unterprogramm11() {
  if (( analogRead(A6) > 600 )) {
      mennue = ( mennue + 1 );
      delay( 600 );
      menue = LOW;
    }
  if (( analogRead(A6) < 400 )) {
      mennue = ( mennue - 1 );
      delay( 600 );
      menue = LOW;
    }
}

//PAR 1
void Unterprogramm2() {
  if (( mennue == 19 )) {
      lcd1.clear();
      lcd1.setCursor(1,0);
      lcd1.print("PAR 1 RGB");
      delay( 700 );
      menue = HIGH;
      while ( ( menue == HIGH ) ) 	{
          Unterprogramm();
          Unterprogramm11();
          if (digitalRead(8)) {
              DmxSimple.write(1, brightness1);
              DmxSimple.write(2, brightness2);
              DmxSimple.write(3, brightness3);
              DmxSimple.write(4, brightness4);
            }
          if (digitalRead(7)) {
              Unterprogramm99();
            }
          Unterprogramm34();
          Unterprogramm37();
        }

    }
  if (( mennue == 18 )) {
      lcd1.clear();
      lcd1.setCursor(1,0);
      lcd1.print("PAR 1 mix");
      delay( 700 );
      menue = HIGH;
      while ( ( menue == HIGH ) ) 	{
          ZeitVariable = millis();
          while(ZeitVariable + 400L >= millis()) {		
              Unterprogramm();
              Unterprogramm11();
              if (digitalRead(8)) {
                  DmxSimple.write(5, brightness2);
                  DmxSimple.write(6, brightness3);
                  DmxSimple.write(7, brightness4);
                }
              if (digitalRead(7)) {
                  Unterprogramm98();
                }
              lcd1.setCursor(1,0);
              lcd1.print("PAR 1 mix");
              lcd1.setCursor(0,1);
              lcd1.print(brightness2 );
              lcd1.setCursor(5,1);
              lcd1.print(brightness3 );
              lcd1.setCursor(10,1);
              lcd1.print(brightness4 );
            }
          lcd1.clear();
        }

    }
}

//moving head 2
void Unterprogramm8() {
  if (( mennue == 24 )) {
      lcd1.clear();
      lcd1.setCursor(1,0);
      lcd1.print("MH. 2 - 1");
      lcd1.setCursor(0,1);
      lcd1.print("STO");
      lcd1.setCursor(4,1);
      lcd1.print("GOB");
      lcd1.setCursor(8,1);
      lcd1.print("COL");
      lcd1.setCursor(12,1);
      lcd1.print("DIM");
      delay( 700 );
      menue = HIGH;
      while ( ( menue == HIGH ) ) 	{
          Unterprogramm();
          Unterprogramm11();
          if (digitalRead(8)) {
              DmxSimple.write(46, brightness1);
              DmxSimple.write(45, brightness4);
              DmxSimple.write(44, brightness3);
              DmxSimple.write(47, brightness2);
            }
          if (digitalRead(7)) {
            }
        }

    }
  if (( mennue == 25 )) {
      lcd1.clear();
      lcd1.setCursor(1,0);
      lcd1.print("MH 2 - 2");
      delay( 700 );
      menue = HIGH;
      while ( ( menue == HIGH ) ) 	{
          ZeitVariable = millis();
          while(ZeitVariable + 400L >= millis()) {		
              Unterprogramm();
              Unterprogramm11();
              Unterprogramm50();
              if (digitalRead(8)) {
                  Unterprogramm50();
                  DmxSimple.write(48, brightness1);
                  DmxSimple.write(49, brightness2);
                  DmxSimple.write(50, brightness5);
                }
              if (digitalRead(7)) {
                }
            }
          lcd1.clear();
        }

    }
}

//PAR 2
void Unterprogramm3() {
  if (( mennue == 17 )) {
      lcd1.clear();
      lcd1.setCursor(1,0);
      lcd1.print("PAR 2 RGB");
      delay( 700 );
      menue = HIGH;
      while ( ( menue == HIGH ) ) 	{
          Unterprogramm();
          Unterprogramm11();
          if (digitalRead(8)) {
              DmxSimple.write(8, brightness1);
              DmxSimple.write(9, brightness2);
              DmxSimple.write(10, brightness3);
              DmxSimple.write(11, brightness4);
            }
          if (digitalRead(7)) {
              Unterprogramm99();
            }
          Unterprogramm34();
          Unterprogramm37();
        }

    }
  if (( mennue == 16 )) {
      lcd1.clear();
      lcd1.setCursor(1,0);
      lcd1.print("PAR 2 mix");
      delay( 700 );
      menue = HIGH;
      while ( ( menue == HIGH ) ) 	{
          ZeitVariable = millis();
          while(ZeitVariable + 400L >= millis()) {		
              Unterprogramm();
              Unterprogramm11();
              if (digitalRead(8)) {
                  DmxSimple.write(12, brightness2);
                  DmxSimple.write(13, brightness3);
                  DmxSimple.write(14, brightness4);
                }
              if (digitalRead(7)) {
                  Unterprogramm98();
                }
              lcd1.setCursor(1,0);
              lcd1.print("PAR 2 mix");
              lcd1.setCursor(0,1);
              lcd1.print(brightness2 );
              lcd1.setCursor(5,1);
              lcd1.print(brightness3 );
              lcd1.setCursor(10,1);
              lcd1.print(brightness4 );
            }
          lcd1.clear();
        }

    }
}

//DMX Start
void Unterprogramm33() {
  brightness1 = EEPROM.read( 1 )  ;
  brightness2 = EEPROM.read( 2 )  ;
  brightness3 = EEPROM.read( 3 )  ;
  brightness4 = EEPROM.read( 4 )  ;
  brightness5 = EEPROM.read( 5 )  ;
  DmxSimple.write(1, brightness1);
  DmxSimple.write(2, brightness2);
  DmxSimple.write(3, brightness3);
  DmxSimple.write(4, brightness4);
  DmxSimple.write(8, brightness1);
  DmxSimple.write(9, brightness2);
  DmxSimple.write(10, brightness3);
  DmxSimple.write(11, brightness4);
  DmxSimple.write(15, brightness1);
  DmxSimple.write(16, brightness2);
  DmxSimple.write(17, brightness3);
  DmxSimple.write(18, brightness4);
  DmxSimple.write(22, brightness1);
  DmxSimple.write(23, brightness2);
  DmxSimple.write(24, brightness3);
  DmxSimple.write(25, brightness4);
}

//alle auf mix
void Unterprogramm98() {
  DmxSimple.write(5, brightness2);
  DmxSimple.write(6, brightness3);
  DmxSimple.write(7, brightness4);
  DmxSimple.write(12, brightness2);
  DmxSimple.write(13, brightness3);
  DmxSimple.write(14, brightness4);
  DmxSimple.write(19, brightness2);
  DmxSimple.write(20, brightness3);
  DmxSimple.write(21, brightness4);
  DmxSimple.write(26, brightness2);
  DmxSimple.write(27, brightness3);
  DmxSimple.write(28, brightness4);
}

//DMX speicher
void Unterprogramm34() {
  if (( analogRead(A7) < 400 )) {
      Unterprogramm();
      EEPROM.write( 1 , brightness1 ) ;
      EEPROM.write( 2 , brightness2 ) ;
      EEPROM.write( 3 , brightness3 ) ;
      EEPROM.write( 4 , brightness4 ) ;
      analogWrite(5 , 120);
      delay( 500 );
      analogWrite(5 , 0);
    }
}

//PAR 3
void Unterprogramm4() {
  if (( mennue == 15 )) {
      lcd1.clear();
      lcd1.setCursor(1,0);
      lcd1.print("PAR 3 RGB");
      delay( 700 );
      menue = HIGH;
      while ( ( menue == HIGH ) ) 	{
          Unterprogramm();
          Unterprogramm11();
          if (digitalRead(8)) {
              DmxSimple.write(15, brightness1);
              DmxSimple.write(16, brightness2);
              DmxSimple.write(17, brightness3);
              DmxSimple.write(18, brightness4);
            }
          if (digitalRead(7)) {
              Unterprogramm99();
            }
          Unterprogramm34();
          Unterprogramm37();
        }

    }
  if (( mennue == 14 )) {
      lcd1.clear();
      lcd1.setCursor(1,0);
      lcd1.print("PAR 3 mix");
      delay( 700 );
      menue = HIGH;
      while ( ( menue == HIGH ) ) 	{
          ZeitVariable = millis();
          while(ZeitVariable + 400L >= millis()) {		
              Unterprogramm();
              Unterprogramm11();
              if (digitalRead(8)) {
                  DmxSimple.write(19, brightness2);
                  DmxSimple.write(20, brightness3);
                  DmxSimple.write(21, brightness4);
                }
              if (digitalRead(7)) {
                  Unterprogramm98();
                }
              lcd1.setCursor(1,0);
              lcd1.print("PAR 3 mix");
              lcd1.setCursor(0,1);
              lcd1.print(brightness2 );
              lcd1.setCursor(5,1);
              lcd1.print(brightness3 );
              lcd1.setCursor(10,1);
              lcd1.print(brightness4 );
            }
          lcd1.clear();
        }

    }
}

//PAR 4
void Unterprogramm5() {
  if (( mennue == 13 )) {
      lcd1.clear();
      lcd1.setCursor(1,0);
      lcd1.print("PAR 4 RGB");
      delay( 700 );
      menue = HIGH;
      while ( ( menue == HIGH ) ) 	{
          Unterprogramm();
          Unterprogramm11();
          if (digitalRead(8)) {
              DmxSimple.write(22, brightness1);
              DmxSimple.write(23, brightness2);
              DmxSimple.write(24, brightness3);
              DmxSimple.write(25, brightness4);
            }
          if (digitalRead(7)) {
              Unterprogramm99();
            }
        }

      Unterprogramm34();
      Unterprogramm37();
    }
  if (( mennue == 12 )) {
      lcd1.clear();
      lcd1.setCursor(1,0);
      lcd1.print("PAR 4 mix");
      delay( 700 );
      menue = HIGH;
      ZeitVariable = millis();
      while(ZeitVariable + 400L >= millis()) {		
          Unterprogramm();
          if (( analogRead(A6) > 600 )) {
              mennue = ( mennue + 1 );
              delay( 600 );
              menue = LOW;
            }
          if (digitalRead(8)) {
              DmxSimple.write(19, brightness2);
              DmxSimple.write(20, brightness3);
              DmxSimple.write(21, brightness4);
            }
          if (digitalRead(7)) {
              Unterprogramm98();
            }
          lcd1.setCursor(1,0);
          lcd1.print("PAR 4 mix");
          lcd1.setCursor(0,1);
          lcd1.print(brightness2 );
          lcd1.setCursor(5,1);
          lcd1.print(brightness3 );
          lcd1.setCursor(10,1);
          lcd1.print(brightness4 );
        }
      lcd1.clear();
    }
}

//brithnessanalog
void Unterprogramm() {
  brightness1 = map ( analogRead(A3) , 0 , 900 , 0 , 255 ) ;
  brightness2 = map ( analogRead(A0) , 0 , 900 , 0 , 255 ) ;
  brightness3 = map ( analogRead(A1) , 0 , 900 , 0 , 255 ) ;
  brightness4 = map ( analogRead(A2) , 0 , 900 , 0 , 255 ) ;
  brightness1 = constrain( brightness1 , 0 , 255 ) ;
  brightness2 = constrain( brightness2 , 0 , 255 ) ;
  brightness3 = constrain( brightness3 , 0 , 255 ) ;
  brightness4 = constrain( brightness4 , 0 , 255 ) ;
  brightness5 = constrain( brightness3 , 0 , 249 ) ;
}

//alle auf RGB
void Unterprogramm99() {
  DmxSimple.write(1, brightness1);
  DmxSimple.write(2, brightness2);
  DmxSimple.write(3, brightness3);
  DmxSimple.write(4, brightness4);
  DmxSimple.write(8, brightness1);
  DmxSimple.write(9, brightness2);
  DmxSimple.write(10, brightness3);
  DmxSimple.write(11, brightness4);
  DmxSimple.write(15, brightness1);
  DmxSimple.write(16, brightness2);
  DmxSimple.write(17, brightness3);
  DmxSimple.write(18, brightness4);
  DmxSimple.write(22, brightness1);
  DmxSimple.write(23, brightness2);
  DmxSimple.write(24, brightness3);
  DmxSimple.write(25, brightness4);
}

//DMX speicher
void Unterprogramm37() {
  if (( analogRead(A7) > 600 )) {
      Unterprogramm();
      EEPROM.write( 1 , brightness1 ) ;
      EEPROM.write( 2 , brightness2 ) ;
      EEPROM.write( 3 , brightness3 ) ;
      EEPROM.write( 4 , brightness4 ) ;
      EEPROM.write( 8 , brightness1 ) ;
      EEPROM.write( 9 , brightness2 ) ;
      EEPROM.write( 10 , brightness3 ) ;
      EEPROM.write( 4 , brightness4 ) ;
      EEPROM.write( 15 , brightness1 ) ;
      EEPROM.write( 16 , brightness2 ) ;
      EEPROM.write( 17 , brightness3 ) ;
      EEPROM.write( 18 , brightness4 ) ;
      EEPROM.write( 22 , brightness1 ) ;
      EEPROM.write( 23 , brightness2 ) ;
      EEPROM.write( 24 , brightness3 ) ;
      EEPROM.write( 25 , brightness4 ) ;
      analogWrite(5 , 120);
      delay( 500 );
      analogWrite(5 , 0);
    }
}
